# ReleaseInstances

## 1. API Description

This API is used to release instances.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Only operations on instances in recycle bin are supported.</mark>
* <mark style="color:blue;">Batch operations are supported. The maximum number of instances in each request is 100.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                                                                                        |
| -------------- | -------- | --------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds    | Yes      | Array of String | <p>Instance ID(s).</p><p>To obtain the instance IDs, you can call <a href="describeinstances"><code>DescribeInstances</code></a> and look for <code>instanceId</code> in the response. The maximum number of instances in each request is 100.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                              |
| -------------- | ------ | -------------------------------------------------------------------------------------------------------- |
| requestId      | String | The unique request ID, which is returned for each request. RequestId is required for locating a problem. |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Release two instances**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ReleaseInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ]
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk) to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).​

| HTTP Status Code | Error Code                                 | Description                                                |
| ---------------- | ------------------------------------------ | ---------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND              | Instance does not exist.                                   |
| 403              | OPERATION\_DENIED\_INSTANCE\_NOT\_RECYCLED | Only operations on instances in recycle bin are supported. |
